#ifndef _AESTEST_H_
#define _AESTEST_H_

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include "AES.h"

class AESTest :public CppUnit::TestCase {
	CPPUNIT_TEST_SUITE(AESTest);
	CPPUNIT_TEST(testSizeofWord);	
	CPPUNIT_TEST(testByteXor);
	CPPUNIT_TEST(testByteSimpleMul);
	CPPUNIT_TEST(testByteDiv);
	CPPUNIT_TEST(testByteMul);
	CPPUNIT_TEST(testGenerateKey);
	CPPUNIT_TEST(testGetBytes);
	CPPUNIT_TEST(testSubWord);
	CPPUNIT_TEST(testRotWord);
	CPPUNIT_TEST(testExpandKey);
	CPPUNIT_TEST(testInvertWords);
	CPPUNIT_TEST(testInvertWordsInPlace);
	CPPUNIT_TEST(testSubBytes);
	CPPUNIT_TEST(testShiftRows);
	CPPUNIT_TEST(testMixColumns);
	CPPUNIT_TEST(testEncrypt);
	CPPUNIT_TEST(testShiftRowsInv);
	CPPUNIT_TEST(testSubBytesInv);
	CPPUNIT_TEST(testSubBytesInv2);
	CPPUNIT_TEST(testSetByte);
	CPPUNIT_TEST(testMixColumnsInv);
	CPPUNIT_TEST(testMixColumnsInv2);
	CPPUNIT_TEST(testDecrypt);
	CPPUNIT_TEST_SUITE_END();
	
public:
	void setUp();
	void tearDown();
	void testSizeofWord();
	void testByteXor();
	void testByteSimpleMul();
	void testByteDiv();
	void testByteMul();
	void testGenerateKey();
	void testGetBytes();
	void testSubWord();
	void testRotWord();
	void testExpandKey();
	void testInvertWords();
	void testInvertWordsInPlace();
	void testSubBytes();
	void testShiftRows();
	void testMixColumns();
	void testEncrypt();
	void testDecrypt();
	void testShiftRowsInv();
	void testSubBytesInv();
	void testSubBytesInv2();
	void testMixColumnsInv();
	void testMixColumnsInv2();
	void testSetByte();
};

#endif//_AESTEST_H_
