#include <mpnt/mpnt.h>
using namespace MpNT;

#include <exception>

#include "ChineseRemainderTheorem.h"

MpInt chinese_remainder_theorem(vector<MpInt> b, vector<MpInt> mods)
{
	if (b.size() != mods.size())
		throw std::length_error("Vectors not same size");
	int k = b.size();
	MpInt m = 1, x0, x, c;

	for (int i=0; i<k; i++)
		m *= mods[i];
	MpModulus mm(m);
	for (int i=0; i<k; i++)
	{
		//c = m / mods[i];
		div_q(c, m, mods[i]);
		MpModulus mmi(mods[i]);
		red_mod(x, c, mmi);
		inv_mod(x, x, mmi);
		mul_mod(x, b[i], x, mmi);
		mul_mod(x, c, x, mm);
		add_mod(x0, x0, x, mm);
	}
	return x0;
}
