#ifndef _DESTEST_H_
#define _DESTEST_H_

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include "DES.h"

class DESTest :public CppUnit::TestCase {
	CPPUNIT_TEST_SUITE(DESTest);
	CPPUNIT_TEST(testGenerateKey);
	CPPUNIT_TEST(testPC1);
	CPPUNIT_TEST(testPC2);
	CPPUNIT_TEST(testLSi);
	CPPUNIT_TEST(testComputeRoundKeys);
	CPPUNIT_TEST(testP0);
	CPPUNIT_TEST(testP0Inv);
	CPPUNIT_TEST(testRev);
	CPPUNIT_TEST(testRev2);
	CPPUNIT_TEST(testP0AndP0Inv);
	CPPUNIT_TEST(testE);
	CPPUNIT_TEST(testP);
	CPPUNIT_TEST(testEncryptDecrypt);
	CPPUNIT_TEST_SUITE_END();

private:
	MpInt key;
	vector<MpInt> round_keys;
	
public:
	DESTest() {
		key = DES::generate_key();
		DES::compute_round_keys(key, round_keys, 16);
	}

	void testGenerateKey();
	void testPC1();
	void testPC2();
	void testLSi();
	void testComputeRoundKeys();
	void testP0();
	void testP0Inv();
	void testRev();
	void testRev2();
	void testP0AndP0Inv();	
	void testE();
	void testP();
	void testEncryptDecrypt();
};

#endif //_DESTEST_H_
