#include <mpnt/mpnt.h>
using namespace MpNT;

#include "MignotteSequence.h"

MignotteSequence::MignotteSequence(unsigned int n_, unsigned int k_,
		unsigned int bits_) : n(n_), k(k_), bits(bits_), m(n_) {
	double prob = 0.00001;
	int t = (int)( ceil (log(1 / prob) / LOG_2)/2 ) + 1;
	do {
		gen_prime (m[0], bits, prob, miller_rabin);
		for (unsigned int i=1; i<n; i++)
		{
			m[i] = m[i-1];
			do
				m[i] += 2;
			while(!miller_rabin(m[i], t));
		}

		alpha = 1;
		for (unsigned int i=0; i<k; i++)
			alpha = alpha * m[i];
		beta = 1;
		for (unsigned int i=n-1; i>n-k; i--)
			beta = beta * m[i];

		bits += 10;
	} while (alpha <= beta);
}
