#include <mpnt/mpnt.h>
using namespace MpNT;

#include <iostream>
using namespace std;

#include "MignotteSequenceTest.h"

void MignotteSequenceTest::setUp() {
	n = 10;
	k = 5;
	bits = 100;
	mseq = new MignotteSequence(n, k, bits);
}

void MignotteSequenceTest::tearDown() {
	delete mseq;
}

void MignotteSequenceTest::testConstructorBasic() {
	CPPUNIT_ASSERT_EQUAL(n, mseq->get_n());
	CPPUNIT_ASSERT_EQUAL(k, mseq->get_k());
	CPPUNIT_ASSERT(bits <= mseq->get_bits());
}

void MignotteSequenceTest::testAlpha() {
	MpInt alpha = 1;
	for (unsigned int i=0; i<mseq->get_k(); i++)
		mul(alpha, alpha, mseq->get_m(i));
	CPPUNIT_ASSERT_EQUAL(alpha, mseq->get_alpha());
}

void MignotteSequenceTest::testBeta() {
	MpInt beta = 1;
	for (unsigned int i=n-1; i>mseq->get_n()-mseq->get_k(); i--)
		mul(beta, beta, mseq->get_m(i));
	CPPUNIT_ASSERT_EQUAL(beta, mseq->get_beta());
}

void MignotteSequenceTest::testAlphaGreaterThanBeta() {
	CPPUNIT_ASSERT(mseq->get_alpha() > mseq->get_beta());
}

void MignotteSequenceTest::testOrdering() {
	for (unsigned int i=1; i<mseq->get_n(); i++) {
		CPPUNIT_ASSERT(mseq->get_m(i) > mseq->get_m(i));
	}
}

void MignotteSequenceTest::testRelativePrime() {
	for (unsigned int i=1; i<mseq->get_n(); i++) {
		for (unsigned int j=1; j<mseq->get_n(); j++) {
			if (i != j) {
				MpInt temp;
//					cout << "m(" << i << "):" << mseq->get_m(i);
//					cout << " m(" << j << "):" << mseq->get_m(j);
				gcd(temp, mseq->get_m(i), mseq->get_m(j));
//					cout << " gcd:" << temp << endl;
				CPPUNIT_ASSERT_EQUAL(MpInt(1), temp);
			}
		}
	}
}
