#include <mpnt/mpnt.h>
using namespace MpNT;

#include <iostream>
using namespace std;

#include "MignotteTest.h"

void MignotteTest::setUp() {
	cout << "setUp - begin" << endl;
	n = 10;
	k = 5;
	bits = 100;
	mseq = new MignotteSequence(n, k, bits);
	mignotte = new Mignotte(*mseq);
	cout << "setUp - end" << endl;
}

void MignotteTest::tearDown() {
	cout << "tearDown - begin" << endl;
//		delete mignotte;
	delete mseq;
	cout << "tearDown -end" << endl;
}

void MignotteTest::testDummy() {
	cout << "testDummy - begin" << endl;
	CPPUNIT_ASSERT(true);
	cout << "testDummy - end" << endl;
}

void MignotteTest::testDummy2() {
	cout << "testDummy2 - begin" << endl;
	CPPUNIT_ASSERT(true);
	cout << "testDummy2 - end" << endl;
}

void MignotteTest::testDummy3() {
	cout << "testDummy3 - begin" << endl;
	CPPUNIT_ASSERT(true);
	cout << "testDummy3 - end" << endl;
}

void MignotteTest::testConstructorBasic() {
	CPPUNIT_ASSERT_EQUAL(mseq->get_n(), mignotte->get_sequence().get_n());
	CPPUNIT_ASSERT_EQUAL(mseq->get_k(), mignotte->get_sequence().get_k());
	CPPUNIT_ASSERT_EQUAL(mseq->get_bits(), mignotte->get_sequence().get_bits());
	CPPUNIT_ASSERT_EQUAL(mseq->get_alpha(), mignotte->get_sequence().get_alpha());
	CPPUNIT_ASSERT_EQUAL(mseq->get_beta(), mignotte->get_sequence().get_beta());
	for (unsigned int i=0; i<mseq->get_n(); i++) {
		CPPUNIT_ASSERT_EQUAL(mseq->get_m(i), mignotte->get_sequence().get_m(i));
	}
}

void MignotteTest::testSecret() {
//		cout << "secret: " << mignotte->get_secret() << endl;
//		cout <<  "beta: " << mseq->get_beta() << endl;
//		cout << " alpha: " << mseq->get_alpha() << endl;
	cmp(mignotte->get_secret(), mseq->get_beta());
	cmp(mignotte->get_secret(), mseq->get_alpha());
	CPPUNIT_ASSERT(cmp(mignotte->get_secret(), mseq->get_beta()) > 0);
	CPPUNIT_ASSERT(cmp(mignotte->get_secret(), mseq->get_alpha()) < 0);		
}
