#ifndef _SHAMIRTEST_H_
#define _SHAMIRTEST_H_

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>
#include "Shamir.h"

class ShamirTest :public CppUnit::TestCase {
	CPPUNIT_TEST_SUITE(ShamirTest);
	CPPUNIT_TEST(testConstructorBasic);
	CPPUNIT_TEST(testQPrime);
	CPPUNIT_TEST(testSecret);
	CPPUNIT_TEST(testSubsecretsBasic);
	CPPUNIT_TEST_EXCEPTION(testGetSubsecretException, std::out_of_range);
	CPPUNIT_TEST(testSubsecretsValid);
	CPPUNIT_TEST(testSubsecretsValid2);
	CPPUNIT_TEST_FAIL(testSubsecretsInvalid);
	CPPUNIT_TEST_FAIL(testSubsecretsInvalid2);
	CPPUNIT_TEST_SUITE_END();

public:
	void setUp();		
	void tearDown();
	void testConstructorBasic();
	void testQPrime();
	void testSecret();
	void testSubsecretsBasic();
	void testGetSubsecretException() throw (std::out_of_range);
	void testSubsecretsValid();
	void testSubsecretsValid2();
	void testSubsecretsInvalid();
	void testSubsecretsInvalid2();
	
private:
	Shamir *shamir;
	unsigned int n, k, bits;
};

#endif //_SHAMIRTEST_H_
