#include <mpnt/mpnt.h>
using namespace MpNT;

#include <vector>
#include <iostream>
#include <string>
#include <exception>
using namespace std;

#include "VigenereTest.h"

VigenereTest::VigenereTest() {
	text = "However many hours in the air now, her watch tucked ritually out of sight, dinner served, lights dimmed, she\
		imagines her soul bobbing stupidly, somewhere back over the concrete of Heathrow, its invisible tether\
		spooling steadily out of her. As does a certain degree of fear, she notes, now that she knows they must be far\
		out over an ocean, where no human agents threaten. For most of her life, flying, shed felt most vulnerable\
		right here, suspended in a void, above trackless water, but now her conscious flying?fears are about things\
		that might be arranged to happen over populous human settlements, fears of ground?to?air, of scripted CNN\
		moments.But commercial aircraft have also been problematic for Cayce in another way, with their endless\
		claustrophobic repetition of the carriers logo. BA has never been particularly difficult, but Virgin, with its\
		multi?pronged product?associations, is completely impossible\
		Keiko/Judy is simultaneously pubescent and aggressively womanly, her shapely yet slender legs spilling out\
		of a tiny tartan schoolgirl kilt, to vanish, mid?calf, into shoved?down, bunched?up cotton kneesocks of an\
		unusually heavy knit. Cayce's cool?module, wherever it resides, has always proven remarkably good at\
		registering the salient parameters of fetishes she's never encountered before, and doesn't in the least\
		respond to. She just knows now that these Big Sox are one of those, and probably culture?specific. There will\
		be a magazine for Japanese guys into big socks, she's sure of it. The big socks go into retro faux?Converse\
		canvas, but with platform soles to balance the very sizable bulk of sock?scrunch around the ankles, giving\
		Keiko/Judy a knees?down look recalling a baby Clydesdale.\
		e settles at a Scandinavian?looking counter of pale wood that runs the length of a window overlooking the\
		street and the entrance to Parco, and unpacks the laptop, phone, and manuals. She's not one of those people\
		who won't ever read the manual, although she'll skip it if she can. Ten minutes of concerted attention has\
		on the screen, wireless fully effected, so she sweetens her lemon tea and checks out the action. She\
		knows this stage, after a new segment turns up: Everyone's had a chance to view it repeatedly, and brainstorm,\
		and now the more personal, more deeply felt interpretations are emerging.\
		If Taki was in love before, he is now in lust. Or maybe the other way around. But in his new frenzy of\
		adoration and desire to please, he has sent this, which he explains to Keiko is the latest from Mystic. Darryl,\
		who has otaku DNA himself, is convinced that Taki is not a member of this Mystic, but a peripheral character\
		of some kindpossibly, since he designs games for a Japanese phone system, one of their sources of\
		information. Darryl says that the highest level of play, for techno?obsessives, is always and purely about\
		information itself, and he thinks that Mystic may have battened on the footage not in a footagehead way but\
		simply for the sake of solving a puzzle that no one else has solved. He posits a cell of professional\
		info?theorists, of some kind, who are also, in this ultimate otaku sense, info?junkies. Perhaps employed in the\
		R&D arm of one or more large corporations. Perhaps they need something that Taki knows. It doesn't matter,\
		really, since Taki seems somehow to have reversed the flow of data, and the psycho?sexual cruise missile that\
		is Judy, tweaked, has found its mark. To save you the trouble of counting them, there are one hundred and\
		thirty?five numbers, here, each number consisting of three groups of four digits.";
	
	wrong_text = 
		"4occsgv5lcbfbgxlbiwgd2hhdokamwqgew91igrvihrvienoyxjsawuriekgbmv2zxigc2f3ighpbsb\
		hy3qgbglrzsb0agf0igjlzm9yzs7igj0nckkgzglkbukamxqga25vdyb3agf0ihrvigrvig9yihdozxj\
		lihrvihr1cm4uiev2zxj5b25lihdhcybsb29raw5nigf0ig1ligfuzcbsyxvnagluzybhbmqgssbmzwx\
		0ig5ha2vklibjihdhbnrlzcb0byboawrlig15c2vszi4gssbyyw4gb3v0igludg8gdghlihn0cmvldcb\
		hbmqgssb0ahjldyb1cc4gvghlbibjihdhbgtlzcbob21llibjdokamxmgysbmdw5uesb0agluzybjig5\
		ldmvyigtuzxcgdghhdcbkb2ugyw5kiezyyw5rigfuzcb0agugb3rozxjzigxpa2vkihrvighhdmugbwu\
		gyxjvdw5kigfsbcb0agugdgltzsb0bybtywtligz1bibvzibtzs4nck5vdybjigtub3cgd2hhdcbpdcb\
		tzwfucyb3agvuihrozxkgc2f5iokanhrvihb1bgwgysbdagfybglliedvcsktzg9ulukanq0ksekamw0\
		gyxnoyw1lzc4ncg0kufjpr1jfu1mgukvqt1juidexdqpbchjpbcaymekalfn0awxsigrpzg7igjl0igd\
		vigludg8gdghligzhy3rvcnkuiekgdg9szcbncnmuiezsew5uig15igxhbmrsywr5ihrvignhbgwgyw5\
		kihrlbgwgtxiuiervbm5lz2fuiekgd2fzihnpy2suie1ycy4grmx5bm4gbg9va3mgyxqgbwugdmvyesb\
		mdw5uesbsyxrlbhkgbglrzsbzagxigjlzihnjyxjlzcbvzibtzs4nckkgdghpbmsgaxtigjlzigegz29\
		4occsgv5lcbfbgxlbiwgd2hhdokamwqgew91igrvihrvienoyxjsawu/iekgbmv2zxigc2f3ighpbsfb\
		hy3qgbglrzsb0agf0igjlzm9yzs7igj0nckkgzglkbukamxqga25vdyb3agf0ihrvigrvig9yihdozxj\
		lihrvihr1cm4uiev2zxj5b25lihdhcybsb29raw5nigf0ig1ligfuzcbsyxvnagluzybhbmqgssbmzwx\
		0ig5ha2vklibjihdhbnrlzcb0byboawrlig15c2vszi4gssbyyw4gb3v0igludg8gdghlihn0cmvldcb\
		hbmqgssb0ahjldyb1cc4gvghlbibjihdhbgtlzcbob21llibjdokamxmgysbmdw5uesb0agluzybjig5\
		ldmvyigtuzxcgdghhdcbkb2ugyw5kiezyyw5rigfuzcb0agugb3rozxjzigxpa2vkihrvighhdmugbwu\
		gyxjvdw5kigfsbcb0agugdgltzsb0bybtywtligz1bibvzibtzs4nck5vdybjigtub3cgd2hhdcbpdcb\
		tzwfucyb3agvuihrozxkgc2f5iokanhrvihb1bgwgysbdagfybglliedvcsktzg9ulukanq0ksekamw0\
		gyxnoyw1lzc4ncg0kufjpr1jfu1mgukvqt1juidexdqpbchjpbcaymekalfn0awxsigrpzg7igjl0igd\
		vigludg8gdghligzhy3rvcnkuiekgdg9szcbncnmuiezsew5uig15igxhbmrsywr5ihrvignhbgwgyw5\
		kihrlbgwgtxiuiervbm5lz2fuiekgd2fzihnpy2suie1ycy4grmx5bm4gbg9va3mgyxqgbwugdmvyesb\
		mdw5uesbsyxrlbhkgbglrzsbzagxigjlzihnjyxjlzcbvzibtzs4nckkgdghpbmsgaxtigjlzigegz29";
}

void VigenereTest::testConvert() {
	string s = "anaaremere";
	vector<int> arr;
	Vigenere::convert(s, arr);
	for (int i=0; i<10; i++) {
		CPPUNIT_ASSERT_EQUAL((int)(s[i]-'a'), arr[i]);
	}
}

void VigenereTest::testConvertException() {
	string s = "ana are mere";
	vector<int> arr;
	Vigenere::convert(s, arr);
}

void VigenereTest::testGenKey() {
	int m = 10;
	vector<int> arr;
	Vigenere::gen_key(m, arr);
	for (int i=0; i<m; i++) {
		CPPUNIT_ASSERT(arr[i] >= 0);
		CPPUNIT_ASSERT(arr[i] < 26);
	}
}

void VigenereTest::testConvert2() {
	string s = "anaaremereanaaremereanaar";
	vector<int> arr;
	string s2;
	Vigenere::convert(s, arr);
	Vigenere::convert(arr, s2);
//		cout << "s:" << s << endl;
//		cout << "s2:" << s2 << endl;
	for (int i=0; i<25; i++) {
		CPPUNIT_ASSERT_EQUAL(s[i], s2[i]);
	}		
}

void VigenereTest::testEncryptDecrypt() {
	string text = "anaaremereanaaremereanaar";
	vector<int> x;
	vector<int> xx;
	vector<int> y;
	Vigenere v(10);
	Vigenere::convert(text, x);
	v.encrypt(x, y);
	v.decrypt(y, xx);
//		cout << "x:";
//		for (int i=0; i<25; i++) {
//			cout << x[i] << " ";
//		}
//		cout << endl;
//
//		cout << "y:";
//		for (int i=0; i<25; i++) {
//			cout << y[i] << " ";
//		}
//		cout << endl;
//		
//		cout << "xx:";
//		for (int i=0; i<25; i++) {
//			cout << xx[i] << " ";
//		}
//		cout << endl;
	for (int i=0; i<25; i++) {
		CPPUNIT_ASSERT_EQUAL(x[i], xx[i]);
	}
}

void VigenereTest::testEncryptDecryptString() {
	string x = "anaaremereanaaremereanaar";
	string y, xx;
	Vigenere v(10);
	v.encrypt(x, y);
	v.decrypt(y, xx);
//		cout << "x:";
//		cout << endl;
//
//		cout << "y:";
//		cout << endl;
//		
	CPPUNIT_ASSERT_EQUAL(x, xx);
}

void VigenereTest::testClearText() {
	string cleared;
	Vigenere::clear_text(text, cleared);
	for (unsigned int i=0; i<cleared.size(); i++) {
		CPPUNIT_ASSERT(cleared[i] >= 'a' && cleared[i] <= 'z');
	}
}

void VigenereTest::testIC()
{
	string cleared;
	Vigenere::clear_text(text, cleared);
	Vigenere v(10);
	CPPUNIT_ASSERT_DOUBLES_EQUAL(Vigenere::IC_ENGLISH, v.IC(cleared), Vigenere::DELTA);
}

void VigenereTest::testICFail()
{
	string cleared;
	Vigenere::clear_text(wrong_text, cleared);		
	double ic = Vigenere::IC(cleared);
	CPPUNIT_ASSERT_DOUBLES_EQUAL(Vigenere::IC_ENGLISH, ic, Vigenere::DELTA);
}

void VigenereTest::testGetMByM()
{
	string s = "asdfasdfasdfasdf";	
	string s1; 
	Vigenere::m_by_m_starting_j(s, 0, 4, s1);
	CPPUNIT_ASSERT_EQUAL(string("aaaa"), s1);
	Vigenere::m_by_m_starting_j(s, 1, 4, s1);
	CPPUNIT_ASSERT_EQUAL(string("ssss"), s1);
	Vigenere::m_by_m_starting_j(s, 2, 4, s1);
	CPPUNIT_ASSERT_EQUAL(string("dddd"), s1);
	Vigenere::m_by_m_starting_j(s, 3, 4, s1);
	CPPUNIT_ASSERT_EQUAL(string("ffff"), s1);
	Vigenere::m_by_m_starting_j(s, 0, 1, s1);
	CPPUNIT_ASSERT_EQUAL(s, s1);
	Vigenere::m_by_m_starting_j(s, 4, 1, s1);
	CPPUNIT_ASSERT_EQUAL(string("asdfasdfasdf"), s1);
}

void VigenereTest::testComputeKeyLength()
{
	string cleared, y;
	Vigenere::clear_text(text, cleared);
	Vigenere v(15);
	v.encrypt(cleared, y);
	int m = v.compute_key_length(y);
	CPPUNIT_ASSERT_EQUAL(15, m);
}

void VigenereTest::testShift()
{
	string s = "abcabcabcabc";
	string ss;
	Vigenere::shift(s, 0, ss);
	CPPUNIT_ASSERT_EQUAL(s, ss);
	Vigenere::shift(s, 1, ss);
	CPPUNIT_ASSERT_EQUAL(string("bcdbcdbcdbcd"), ss);
	Vigenere::shift(s, 26, ss);
	CPPUNIT_ASSERT_EQUAL(s, ss);
}

void VigenereTest::testMIC()
{
	string cleared;
	Vigenere::clear_text(text, cleared);
	double mic = Vigenere::MIC(cleared);
//		cout << "mic: " << mic << endl;
	CPPUNIT_ASSERT_DOUBLES_EQUAL(Vigenere::IC_ENGLISH, mic, Vigenere::DELTA);
}

void VigenereTest::testMICFail()
{
	string cleared;
	Vigenere::clear_text(wrong_text, cleared);		
	double mic = Vigenere::MIC(cleared);
//		cout << "wrong mic: " << mic << endl;
	CPPUNIT_ASSERT_DOUBLES_EQUAL(Vigenere::IC_ENGLISH, mic, Vigenere::DELTA);
}

void VigenereTest::testAtack()
{
	string cleared, criptotext;
	Vigenere::clear_text(text, cleared);
	Vigenere v(10);
	vector<int> key, realkey = v.get_key();
	v.encrypt(cleared, criptotext);
	Vigenere::atack(criptotext, key);
	
	CPPUNIT_ASSERT_EQUAL(realkey.size(), key.size());
	for (unsigned int i=0; i<key.size(); i++)
		CPPUNIT_ASSERT_EQUAL(realkey[i], key[i]);
	
}
