#ifndef _VIGENERETEST_H_
#define _VIGENERETEST_H_

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include "Vigenere.h"

class VigenereTest :public CppUnit::TestCase {
	CPPUNIT_TEST_SUITE(VigenereTest);
	CPPUNIT_TEST(testConvert);
//	CPPUNIT_TEST_EXCEPTION(testConvertException, std::out_of_range);
	CPPUNIT_TEST(testGenKey);
	CPPUNIT_TEST(testConvert2);
	CPPUNIT_TEST(testEncryptDecrypt);
	CPPUNIT_TEST(testEncryptDecryptString);
	CPPUNIT_TEST(testClearText);
	CPPUNIT_TEST(testIC);
	CPPUNIT_TEST_FAIL(testICFail);	
	CPPUNIT_TEST(testGetMByM);
	CPPUNIT_TEST(testComputeKeyLength);		
	CPPUNIT_TEST(testShift);
	CPPUNIT_TEST(testMIC);	
	CPPUNIT_TEST_FAIL(testMICFail);
	CPPUNIT_TEST(testAtack);	
	CPPUNIT_TEST_SUITE_END();
	
private:
	string text, wrong_text;

public:
	VigenereTest();
	
	void testConvert();
	void testConvertException();
	void testGenKey();
	void testConvert2();
	void testEncryptDecrypt();
	void testEncryptDecryptString();
	void testClearText();
	void testIC();
	void testICFail();
	void testGetMByM();
	void testComputeKeyLength();
	void testShift();
	void testMIC();
	void testMICFail();
	void testAtack();
};

#endif //_VIGENERETEST_H_
